%% A basic test.
%% Try
%%   c(listsig),
%%   laws:laws(listsig)
%% or (if you only want to see laws about reverse, for example),
%%   laws:laws(listsig, reverse).
%% You could also add some more list functions,
%% or change usort to sort and see what happens.
-module(listsig).
-compile(export_all).

%% Variables that can appear in equations.
var_types() ->
    [{[x,y,z],int}, % X, Y and Z are variables of type int.
     {[xs,ys,zs],list}].

%% Functions that can appear in equations.
fun_types() ->
  %% Module or anonymous function, function name, argument types, result type
    [{erlang,                      '++',          [list, list],   list},
     {fun() -> [] end,             '[]',          [],             list},
     {fun(X, Xs) -> [X|Xs] end,    '|',           [int, list],    list},
     {lists,                       reverse,       [list],         list},
     {lists,                       usort,         [list],         list}].
